from AccessControl import getSecurityManager
from AccessControl.SecurityManagement import newSecurityManager, setSecurityManager

from Products.Five.browser import BrowserView
from Products.CMFCore.utils import getToolByName
from Products.CMFNotification.NotificationTool import ID as TOOL_ID

class EnableSubscribe(BrowserView):
    def __call__(self):
        if self.request['REQUEST_METHOD'] == 'GET':
            return """
                <html>
                    <body>
                        <form method='post' action='"""+self.context.absolute_url()+"""/@@enable_subscribe'>
                            <input type='submit' value='Set email subscription for all users for their content'/>
                        </form>
                    <body>
                </html>"""
        else:
            cat = getToolByName(self.context,'portal_catalog')
            brains = cat({
                'object_provides': [
                    'ubify.coretypes.interfaces.IAudio',
                    'Products.ATContentTypes.interface.news.IATNewsItem',
                    'Products.ATContentTypes.interface.link.IATLink',
                    'ubify.coretypes.interfaces.IDiscussion',
                    'Products.ATContentTypes.interface.event.IATEvent',
                    'Products.ATContentTypes.interface.file.IATFile',
                    'Products.ATContentTypes.interface.image.IATImage',
                    'ubify.coretypes.interfaces.IVideo',
                    'Products.ATContentTypes.interface.archive.IArchivable',
                ],
                'operator': 'or',
            })

            for brain in brains:
                obj = brain.getObject()
                oldSecurityManager = getSecurityManager()
                newSecurityManager(self.request, obj.getOwner())
                ntool = getToolByName(obj, TOOL_ID)
                ntool.subscribeTo(obj)
                setSecurityManager(oldSecurityManager)
                
            brains = cat({'portal_type':'Discussion Item'})
            for brain in brains:
                obj = brain.getObject()
                rootobj = obj.aq_parent.aq_parent                
                oldSecurityManager = getSecurityManager()
                mtool = obj.portal_membership
                tmpuser = mtool.getMemberById(obj.Creator())
                newSecurityManager(self.request, tmpuser.getUser())
                ntool = getToolByName(rootobj, TOOL_ID)
                self.subscribeTo(rootobj, ntool)
                setSecurityManager(oldSecurityManager)

            return "Done"

    def subscribeTo(self, obj, ntool):
        ntool._updateSubscriptionMapping(obj)
        path = ntool._getPath(obj)
        subscribers = ntool._subscriptions.get(path, {})
        user = getSecurityManager().getUser().getId()
        subscribers[user] = 1
        ntool._subscriptions[path] = subscribers
