from zope.interface import implements

from plone.app.portlets.portlets import base
from plone.portlets.interfaces import IPortletDataProvider
from plone.memoize.compress import xhtml_compress
from Products.Five.browser.pagetemplatefile import ViewPageTemplateFile

from Products.CMFCore.utils import getToolByName

class IUnansweredPortlet(IPortletDataProvider):
    """Portlet which renders unanswered topics
    """

class Assignment(base.Assignment):
    implements(IUnansweredPortlet)

    title = u"Awaiting answer"

class Renderer(base.Renderer):
    _template = ViewPageTemplateFile('unansweredtopics.pt')

    def __init__(self, *args):
        base.Renderer.__init__(self, *args)

    def getTopics(self):
        cat = getToolByName(self.context,'portal_catalog')
        brains = cat({'nr_comments':0})
        notcommented = [brain.getObject() for brain in brains]
        return notcommented

    def render(self):
        return xhtml_compress(self._template())

    @property
    def available(self):
        return True

class AddForm(base.NullAddForm):
    def create(self):
        return Assignment()

